# Atomix

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliaconcurrent.github.io/Atomix.jl/dev/)
[![CI](https://github.com/JuliaConcurrent/Atomix.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaConcurrent/Atomix.jl/actions/workflows/ci.yml)

Atomix.jl implements `@atomic`, `@atomicswap`, and `@atomicreplace` that
are superset of the macros in `Base`.  In addition to atomic operations on the
fields as implemented in `Base`, they support atomic operations on array
elements.

```julia
julia> using Atomix: @atomic, @atomicswap, @atomicreplace

julia> A = ones(Int, 3);

julia> @atomic A[1] += 1;  # fetch-and-increment

julia> @atomic A[1]
2

julia> @atomicreplace A[begin+1] 1 => 42  # compare-and-swap
(old = 1, success = true)

julia> @inbounds @atomic :monotonic A[begin+1]  # specify ordering and skip bound check
42

julia> @atomicswap A[end] = 123
1

julia> A[end]
123
```

baremodule Atomix

macro atomic end
macro atomicreplace end
macro atomicswap end

abstract type IndexableRef{Indexable} end

function asstorable end

# Maybe it's useful to make `pointer` customizable for those who want to
# dispatch at the level of UnsafeAtomics?
function pointer end

function gcroot end

function get end
function set! end
function modify! end
function swap! end
function replace! end

module Internal

import ..Atomix: @atomic, @atomicswap, @atomicreplace
using ..Atomix

using Base.Meta: isexpr
using Base: @propagate_inbounds
using UnsafeAtomics:
    Ordering, UnsafeAtomics, monotonic, acquire, release, acq_rel, seq_cst, right

include("utils.jl")
include("references.jl")
include("generic.jl")
include("core.jl")
include("sugar.jl")

function define_docstring()
    path = joinpath(@__DIR__, "..", "README.md")
    include_dependency(path)
    doc = read(path, String)
    doc = replace(doc, r"^```julia"m => "```jldoctest README")
    # Setting `LineNumberNode` to workaround an error from logging(?) `no method
    # matching getindex(::Nothing, ::Int64)`:
    ex = :($Base.@doc $doc Atomix)
    ex.args[2]::LineNumberNode
    ex.args[2] = LineNumberNode(1, Symbol(path))
    Base.eval(Atomix, ex)
end

end  # module Internal

const Ordering = Internal.Ordering

const monotonic = Internal.monotonic
const acquire = Internal.acquire
const release = Internal.release
const acq_rel = Internal.acq_rel
const seq_cst = Internal.seq_cst

# Julia names
const acquire_release = acq_rel
const sequentially_consistent = seq_cst

const right = Internal.UnsafeAtomics.right

Internal.define_docstring()

end  # baremodule Atomix

# TODO: respect ordering
module AtomixCUDAExt

using Atomix: Atomix, IndexableRef
using CUDA: CUDA, CuDeviceArray

const CuIndexableRef{Indexable<:CuDeviceArray} = IndexableRef{Indexable}

function Atomix.get(ref::CuIndexableRef, order)
    error("not implemented")
end

function Atomix.set!(ref::CuIndexableRef, v, order)
    error("not implemented")
end

@inline function Atomix.replace!(
    ref::CuIndexableRef,
    expected,
    desired,
    success_ordering,
    failure_ordering,
)
    ptr = Atomix.pointer(ref)
    expected = convert(eltype(ref), expected)
    desired = convert(eltype(ref), desired)
    begin
        old = CUDA.atomic_cas!(ptr, expected, desired)
    end
    return (; old = old, success = old === expected)
end

@inline function Atomix.modify!(ref::CuIndexableRef, op::OP, x, order) where {OP}
    x = convert(eltype(ref), x)
    ptr = Atomix.pointer(ref)
    begin
        old = if op === (+)
            CUDA.atomic_add!(ptr, x)
        elseif op === (-)
            CUDA.atomic_sub!(ptr, x)
        elseif op === (&)
            CUDA.atomic_and!(ptr, x)
        elseif op === (|)
            CUDA.atomic_or!(ptr, x)
        elseif op === xor
            CUDA.atomic_xor!(ptr, x)
        elseif op === min
            CUDA.atomic_min!(ptr, x)
        elseif op === max
            CUDA.atomic_max!(ptr, x)
        else
            error("not implemented")
        end
    end
    return old => op(old, x)
end

end  # module AtomixCUDAExt

"""
    Atomix.@atomic

A superset of `Base.@atomic` supporting atomic operations on array elements.
Atomic operations on fields dispatches to `Base.@atomic`.
"""
:(@atomic)

macro atomic(ex)
    ans = atomic_impl(QuoteNode(:sequentially_consistent), ex)
    ans === nothing || return ans
    esc(:($Base.@atomic($ex)))
end

macro atomic(order, ex)
    ans = atomic_impl(order, ex)
    ans === nothing || return ans
    esc(:($Base.@atomic($order, $ex)))
end

macro atomic(a1, op, a2)
    ans = atomic_impl(QuoteNode(:sequentially_consistent), a1, op, a2)
    ans === nothing || return ans
    esc(:($Base.@atomic($a1, $op, $a2)))
end

macro atomic(order, a1, op, a2)
    ans = atomic_impl(order, a1, op, a2)
    ans === nothing || return ans
    esc(:($Base.@atomic($order, $a1, $op, $a2)))
end

function ref_expr(ex)
    @nospecialize
    isexpr(ex, :ref) || return nothing
    m = esc(ex.args[1])
    indices = map(esc, ex.args[2:end])
    return :(referenceable($m)[$(indices...)])
end

function order_expr(order)
    @nospecialize
    if order isa QuoteNode
        llvm_ordering_from_juila(order.value)
    else
        :(llvm_ordering_from_juila($(esc(order))))
    end
end

function atomic_impl(order, ex)
    @nospecialize
    if ex isa Expr
        if (ref = ref_expr(ex)) !== nothing
            return :(Atomix.get($ref, $(order_expr(order))))
        elseif isexpr(ex, :call, 3)
            return atomic_impl(order, ex.args[2], ex.args[1], ex.args[3])
        elseif ex.head === :(=)
            l, r = ex.args[1], esc(ex.args[2])
            if (ref = ref_expr(l)) !== nothing
                return :(Atomix.set!($ref, $r, $(order_expr(order))))
            end
        elseif length(ex.args) == 2
            shead = string(ex.head)
            if endswith(shead, '=')
                op = Symbol(shead[1:prevind(shead, end)])
                ans = atomic_impl(order, ex.args[1], op, ex.args[2])
                ans === nothing || return :($ans[2])
            end
        end
    end
    return nothing
end

function atomic_impl(order, a1, op, a2)
    @nospecialize
    ref = ref_expr(a1)
    ref === nothing && return nothing
    :(Atomix.modify!($ref, $(esc(op)), $(esc(a2)), $(order_expr(order))))
end

"""
    Atomix.@atomicswap

A superset of `Base.@atomicswap` supporting atomic operations on array elements.
Atomic operations on fields dispatches to `Base.@atomicswap`.
"""
:(@atomicswap)

macro atomicswap(ex)
    ans = atomicswap_impl(QuoteNode(:sequentially_consistent), ex)
    ans === nothing || return ans
    esc(:($Base.@atomicswap($ex)))
end

macro atomicswap(order, ex)
    ans = atomicswap_impl(order, ex)
    ans === nothing || return ans
    esc(:($Base.@atomicswap($order, $ex)))
end

function atomicswap_impl(order, ex)
    @nospecialize
    isexpr(ex, :(=), 2) || return nothing
    ref = ref_expr(ex.args[1])
    ref === nothing && return nothing
    val = esc(ex.args[2])
    return :(first(Atomix.swap!($ref, $val, $(order_expr(order)))))
end

"""
    Atomix.@atomicreplace

A superset of `Base.@atomicreplace` supporting atomic operations on array
elements.  Atomic operations on fields dispatches to `Base.@atomicreplace`.
"""
:(@atomicreplace)

macro atomicreplace(ex, old_new)
    order = QuoteNode(:sequentially_consistent)
    ans = atomicreplace_impl(order, order, ex, old_new)
    ans === nothing || return ans
    esc(:($Base.@atomicreplace($ex, $old_new)))
end

macro atomicreplace(order, ex, old_new)
    ans = atomicreplace_impl(order, order, ex, old_new)
    ans === nothing || return ans
    esc(:($Base.@atomicreplace($order, $ex, $old_new)))
end

macro atomicreplace(success_order, fail_order, ex, old_new)
    ans = atomicreplace_impl(success_order, fail_order, ex, old_new)
    ans === nothing || return ans
    esc(:($Base.@atomicreplace($success_order, $fail_order, $ex, $old_new)))
end

function atomicreplace_impl(success_order, fail_order, ex, old_new)
    @nospecialize
    ref = ref_expr(ex)
    ref === nothing && return nothing
    so = order_expr(success_order)
    fo = order_expr(fail_order)
    if isexpr(old_new, :call, 3) && old_new.args[1] === :(=>)
        exp, rep = esc(old_new.args[2]), esc(old_new.args[3])
        return :(Atomix.replace!($ref, $exp, $rep, $so, $fo))
    else
        old_new = esc(old_new)
        return :(Atomix.replace!($ref, $old_new::Pair..., $so, $fo))
    end
end

"""
    Atomix.IndexableRef{Indexable}

An object `IndexableRef(data, indices)` represents a *reference* to the location
`data[indices...]`.

A reference object supports `Atomix.pointer`, `Atomix.asstorable`, and `eltype`:

```jldoctest
julia> using Atomix

julia> a = [111, 222, 333];

julia> ref = Atomix.IndexableRef(a, (1,));

julia> Atomix.pointer(ref) === pointer(a, 1)
true

julia> Atomix.asstorable(ref, 1.0)
1

julia> eltype(ref)
$Int
```

To customize the behavior of atomic updates of an `Indexable`, define the following methods:

* `Atomix.get(ref::Atomix.IndexableRef{Indexable}, order) -> v::eltype(ref)`
* `Atomix.set!(ref::Atomix.IndexableRef{Indexable}, v, order)`
* `Atomix.replace!(ref::Atomix.IndexableRef{Indexable}, expected, desired, success_order,
  failure_order) -> (; old, success)`.
* `Atomix.modify!(ref::Atomix.IndexableRef{Indexable}, op, x, order) -> (old => new)`

The ordering arguments (`order`, `success_order`, and `failure_order`) are one of:

* `Atomix.monotonic`
* `Atomix.acquire`
* `Atomix.release`
* `Atomix.acquire_release` (`Atomix.acq_rel`)
* `Atomix.sequentially_consistent` (`Internal.seq_cst`)
"""
Atomix.IndexableRef

Atomix.IndexableRef(data, indices) = IndexableRef(data, indices)

struct IndexableRef{Indexable,Indices} <: Atomix.IndexableRef{Indexable}
    data::Indexable
    indices::Indices
end

"""
    referenceable(mutable) -> r

Return a *referenceable* object `r` whose index and field access yield a *reference* to the
corresponding memory location instead of the value stored.

TODO: record field access

TODO: record nested field and index access to update nested element (e.g.,
array-of-large-structs) atomically?

Note: The idea is identical to Referenceables.jl but Atomix.jl has a minimal implementation
in its internal.
"""
function referenceable end

referenceable(xs::AbstractArray) = ReferenceableArray(xs)

Base.eltype(::Type{<:IndexableRef{Indexable,<:Any}}) where {Indexable} = eltype(Indexable)

const IntIndexableRef{N,Indexable} = IndexableRef{Indexable,NTuple{N,Int}}

# TODO: Use Referenceables.jl?
# TODO: Don't subtype `AbstractArray`?  It is crazy that `xs[1]` and `xs[1, 1]` where
# `xs::ReferenceableArray{2}` return different values.  Or maybe just define `==` on the
# refs?
struct ReferenceableArray{N,Data<:AbstractArray{<:Any,N}} <:
       AbstractArray{Union{IntIndexableRef{1,Data},IntIndexableRef{N,Data}},N}
    data::Data
end

Base.size(a::ReferenceableArray) = size(a.data)
Base.IndexStyle(::Type{<:ReferenceableArray{<:Any,Data}}) where {Data} =
    Base.IndexStyle(Data)

@propagate_inbounds function Base.getindex(a::ReferenceableArray, i::Int)
    @boundscheck checkbounds(a.data, i)
    return IndexableRef(a.data, (i,))::IntIndexableRef{1}
end

@propagate_inbounds function Base.getindex(
    a::ReferenceableArray{N},
    I::Vararg{Int,N},
) where {N}
    @boundscheck checkbounds(a.data, I...)
    return IndexableRef(a.data, I)::IntIndexableRef{N}
end

@inline Atomix.pointer(ref::IntIndexableRef{1}) = pointer(ref.data, ref.indices[1])

@inline function Atomix.pointer(ref::IntIndexableRef)
    i = LinearIndices(ref.data)[ref.indices...]
    return pointer(ref.data, i)
end

Atomix.gcroot(ref) = ref
Atomix.gcroot(ref::IndexableRef) = ref.data

using OpenCL, pocl_jll
using OpenCL: @allowscalar
cl.platform!("pocl")

@testset "AtomixOpenCLExt:extension_found" begin
    @test !isnothing(Base.get_extension(Atomix, :AtomixOpenCLExt))
end


function opencl(f)
    function g()
        f()
        nothing
    end
    OpenCL.@opencl g()
end


# Not implemented:
#=
function test_get_set()
    A = CUDA.ones(Int, 3)
    cuda() do
        GC.@preserve A begin
            ref = Atomix.IndexableRef(A, (1,))
            x = Atomix.get(ref)
            Atomix.set!(ref, -x)
        end
    end
    @test collect(A) == [-1, 1, 1]
end
=#


@testset "AtomixOpenCLExt:test_cas" begin
    idx = (
        data = 1,
        cas1_ok = 2,
        cas2_ok = 3,
        # ...
    )
    @assert minimum(idx) >= 1
    @assert maximum(idx) == length(idx)

    A = OpenCL.zeros(Int32, length(idx))
    opencl() do
        GC.@preserve A begin
            ref = Atomix.IndexableRef(A, (1,))
            (old, success) = Atomix.replace!(ref, 0, 42)
            A[idx.cas1_ok] = old == 0 && success
            (old, success) = Atomix.replace!(ref, 0, 43)
            A[idx.cas2_ok] = old == 42 && !success
        end
    end
    @test collect(A) == [42, 1, 1]
end


@testset "AtomixOpenCLExt:test_inc" begin
    A = OpenCL.CLArray(Int32(1):Int32(3))
    opencl() do
        GC.@preserve A begin
            ref = Atomix.IndexableRef(A, (1,))
            pre, post = Atomix.modify!(ref, +, 1)
            A[2] = pre
            A[3] = post
        end
    end
    @test collect(A) == [2, 1, 2]
end


@testset "AtomixOpenCLExt:test_inc_sugar" begin
    A = OpenCL.ones(Int32, 3)
    opencl() do
        GC.@preserve A begin
            @atomic A[begin] += 1
        end
    end
    @test collect(A) == [2, 1, 1]
end

const _JULIA_ORDERINGS =
    (:unordered, :monotonic, :acquire, :release, :acquire_release, :sequentially_consistent)

@inline function llvm_ordering_from_juila(julia_ordering::Symbol)
    julia_ordering in _JULIA_ORDERINGS || error("unknown ordering: ", julia_ordering)
    return getfield(UnsafeAtomics, julia_ordering)
end

using Atomix
using Atomix.Internal: referenceable
using Atomix: @atomic, @atomicreplace, @atomicswap
using Test


@testset "Aqua.jl" begin
    using Aqua
    Aqua.test_all(Atomix)
end


@testset "test_indexableref" begin
    A = ones(Int, 3)
    ref = Atomix.IndexableRef(A, (1,))
    @test eltype(ref) === Int
    @test Atomix.get(ref) === 1
    Atomix.set!(ref, 123)
    @test Atomix.get(ref) === 123
    @test Atomix.modify!(ref, +, 1) === (123 => 124)
    @test Atomix.get(ref) === 124
    @test Atomix.swap!(ref, 345) == 124
    @test Atomix.get(ref) === 345
    @test Atomix.replace!(ref, 345, 567) === (old = 345, success = true)
    @test Atomix.replace!(ref, 345, 567) === (old = 567, success = false)
end


@testset "test_referenceablearray" begin
    for a in Any[
        ones(Int, 3),
        view(ones(Int, 3), 1:2),
        view(ones(Int, 2, 3), 1:1, 1:2),
        ones(Int, 3)',
    ]
        ra = referenceable(a)
        @test size(ra) == size(a)
        @test IndexStyle(ra) == IndexStyle(a)
    end
end


@testset "test_fallback" begin

    mutable struct Atomic{T}
        @atomic x::T
    end
    
    a = Atomic(123)
    @test (@atomic a.x) == 123
    @test (@atomic :monotonic a.x) == 123
    @atomic a.x = 456
    @test (@atomic a.x) == 456
    @atomic :monotonic a.x = 123
    @test (@atomic a.x) == 123
    @test (@atomic a.x += 111) == 234
    @test (@atomic :monotonic a.x += 111) == 345
    @test (@atomic a.x + 111) == (345 => 456)
    @test (@atomic :monotonic a.x + 111) == (456 => 567)
    @test (@atomicswap a.x = 123) == 567
    @test (@atomicswap :monotonic a.x = 234) == 123
    @test (@atomicreplace a.x 234 => 123) == (old = 234, success = true)
    @test (@atomicreplace a.x 234 => 123) == (old = 123, success = false)
    @test (@atomicreplace :monotonic a.x 123 => 234) == (old = 123, success = true)
    @test (@atomicreplace :monotonic a.x 123 => 234) == (old = 234, success = false)
    @test (@atomicreplace :monotonic :monotonic a.x 234 => 123) ==
          (old = 234, success = true)
    @test (@atomicreplace :monotonic :monotonic a.x 234 => 123) ==
          (old = 123, success = false)
end


@testset "test_get" begin
    A = [42]
    @test (@atomic A[1]) === 42
    @test (@atomic A[end]) === 42
    @test (@atomic :monotonic A[begin]) === 42
    order = :monotonic
    @test (@atomic order A[begin]) === 42
end


@testset "test_get_2d" begin
    A = view([11 12; 21 22], 1:2, 1:2)
    @test IndexStyle(A) isa IndexCartesian
    @test (@atomic A[1]) === 11
    @test (@atomic A[2]) === 21
    @test (@atomic A[end]) === 22
    @test (@atomic A[2, 1]) === 21
    @test (@atomic A[end, 1]) === 21
    @test (@atomic A[1, end]) === 12
end


@testset "test_set" begin
    A = [42, 43]
    @atomic A[1] = 123
    @atomic A[end] = 124
    @test A[1] === 123
    @test A[end] === 124
end


@testset "test_inc" begin
    A = [1, 1]
    @test (@atomic A[1] += 123) === 124
    @test A[1] === 124
    @test (@atomic A[end] += 123) === 124
    @test A[end] === 124
end


@testset "test_swap" begin
    A = [1, 1]
    @test (@atomicswap A[1] = 123) === 1
    @test A[1] === 123
    @test (@atomicswap A[end] = 456) === 1
    @test A[end] === 456
end


@testset "test_cas" begin
    A = [1, 1]
    @test (@atomicreplace A[1] 1 => 123) == (old = 1, success = true)
    @test A[1] === 123
    @test (@atomicreplace A[1] 1 => 456) == (old = 123, success = false)
    @test A[1] === 123
    @test (@atomicreplace A[end] 1 => 789) == (old = 1, success = true)
    @test A[end] === 789
    update = 789 => 123
    @test (@atomicreplace A[end] update) == (old = 789, success = true)
    @test A[end] === 123
end


# KernelAbstractions backend tests
# Pass command-line argument to test suite to install the right backend, e.g.
#   julia> import Pkg
#   julia> Pkg.test("Atomix", test_args=["--Metal"])
if "--Metal" in ARGS
    import Pkg
    Pkg.add("Metal")
    include("test_atomix_metal.jl")
elseif "--CUDA" in ARGS
    import Pkg
    Pkg.add("CUDA")
    include("test_atomix_cuda.jl")
elseif "--oneAPI" in ARGS
    import Pkg
    Pkg.add("oneAPI")
    include("test_atomix_oneapi.jl")
elseif "--OpenCL" in ARGS
    import Pkg
    Pkg.add(["OpenCL", "pocl_jll"])
    include("test_atomix_opencl.jl")
end

# TODO: Support Symbol ordering

"""
    Atomix.get(ref, order) -> x
    Atomix.get(ref) -> x

Atomically load the value `x` stored in `ref` with ordering `order`.  The default ordering
`Atomix.sequentially_consistent` is used when not specified.

# Examples
```jldoctest
julia> using Atomix

julia> a = [111, 222, 333];

julia> ref = Atomix.IndexableRef(a, (1,));

julia> Atomix.get(ref)
111
```
"""
Atomix.get

"""
    Atomix.set!(ref, x, order)
    Atomix.set!(ref, x)

Atomically store the value `x` in `ref` with ordering `order`.  The default ordering
`Atomix.sequentially_consistent` is used when not specified.

# Examples
```jldoctest
julia> using Atomix

julia> a = [111, 222, 333];

julia> ref = Atomix.IndexableRef(a, (1,));

julia> Atomix.set!(ref, 123);

julia> a[1]
123
```
"""
Atomix.set!

"""
    Atomix.modify!(ref, op, x, order) -> (old => new)
    Atomix.modify!(ref, op, x) -> (old => new)

Atomically update `ref` from stored value `old` to `new = op(old, x)` with ordering `order`
(default: `Atomix.sequentially_consistent`).  Return a pair `old => new`.

# Examples
```jldoctest
julia> using Atomix

julia> a = [111, 222, 333];

julia> ref = Atomix.IndexableRef(a, (1,));

julia> Atomix.modify!(ref, +, 123)
111 => 234
```
"""
Atomix.modify!

"""
    Atomix.swap!(ref, new, order) -> old
    Atomix.swap!(ref, new) -> old

Swap the `old` stored in `ref` with the `new` value and establish the memory ordering
`order` (default: `Atomix.sequentially_consistent`).

Notes for implementers: `Atomix.swap!(ref, new, order)` is defined as `Atomix.modify!(ref,
Atomix.right, x, order)`.  Thus, only `Atomix.modify!` has to be defined.

# Examples
```jldoctest
julia> using Atomix

julia> a = [111, 222, 333];

julia> ref = Atomix.IndexableRef(a, (1,));

julia> Atomix.swap!(ref, 123)
111

julia> a[1]
123
```
"""
Atomix.swap!

"""
    Atomix.replace!(ref, expected, desired, success_order, fail_order) -> (; old, success)
    Atomix.replace!(ref, expected, desired, order) -> (; old, success)
    Atomix.replace!(ref, expected, desired) -> (; old, success)

Atomically replace the value stored in `ref` to `desired` if `expected` is stored.  A named
tuple `(; old::eltype(ref), success::Bool)` is returned.

# Examples
```jldoctest
julia> using Atomix

julia> a = [111, 222, 333];

julia> ref = Atomix.IndexableRef(a, (1,));

julia> Atomix.replace!(ref, 111, 123)
(old = 111, success = true)
```
"""
Atomix.replace!

@inline Atomix.get(ref) = Atomix.get(ref, seq_cst)
@inline Atomix.set!(ref, x) = Atomix.set!(ref, x, seq_cst)

@inline Atomix.modify!(ref, op::OP, x) where {OP} = Atomix.modify!(ref, op, x, seq_cst)

@inline Atomix.replace!(ref, expected, desired, order::Ordering = seq_cst) =
    Atomix.replace!(ref, expected, desired, order, order)

@inline Atomix.swap!(ref, x, order::Ordering = seq_cst) =
    first(Atomix.modify!(ref, right, x, order))

# TODO: respect ordering
module AtomixoneAPIExt

using Atomix: Atomix, IndexableRef
using oneAPI: oneAPI, oneDeviceArray

const oneIndexableRef{Indexable<:oneDeviceArray} = IndexableRef{Indexable}

function Atomix.get(ref::oneIndexableRef, order)
    error("not implemented")
end

function Atomix.set!(ref::oneIndexableRef, v, order)
    error("not implemented")
end

@inline function Atomix.replace!(
    ref::oneIndexableRef,
    expected,
    desired,
    success_ordering,
    failure_ordering,
)
    ptr = Atomix.pointer(ref)
    expected = convert(eltype(ref), expected)
    desired = convert(eltype(ref), desired)
    begin
        old = oneAPI.atomic_cmpxchg!(ptr, expected, desired)
    end
    return (; old = old, success = old === expected)
end

@inline function Atomix.modify!(ref::oneIndexableRef, op::OP, x, order) where {OP}
    x = convert(eltype(ref), x)
    ptr = Atomix.pointer(ref)
    begin
        old = if op === (+)
            oneAPI.atomic_add!(ptr, x)
        elseif op === (-)
            oneAPI.atomic_sub!(ptr, x)
        elseif op === (&)
            oneAPI.atomic_and!(ptr, x)
        elseif op === (|)
            oneAPI.atomic_or!(ptr, x)
        elseif op === xor
            oneAPI.atomic_xor!(ptr, x)
        elseif op === min
            oneAPI.atomic_min!(ptr, x)
        elseif op === max
            oneAPI.atomic_max!(ptr, x)
        else
            error("not implemented")
        end
    end
    return old => op(old, x)
end

end  # module AtomixoneAPIExt

using Documenter
using Atomix

makedocs(;
    sitename="Atomix",
    modules=[Atomix],
    format=Documenter.HTML(;
        # Only create web pretty-URLs on the CI
        prettyurls=get(ENV, "CI", nothing) == "true",
    ),
    warnonly=:missing_docs,
)

deploydocs(
    repo="github.com/JuliaConcurrent/Atomix.jl",
    devbranch="main",
    push_preview=true,
)

@inline function Atomix.get(ref, order)
    ptr = Atomix.pointer(ref)
    root = Atomix.gcroot(ref)
    GC.@preserve root begin
        UnsafeAtomics.load(ptr, order)
    end
end

@inline function Atomix.set!(ref, v, order)
    v = Atomix.asstorable(ref, v)
    ptr = Atomix.pointer(ref)
    root = Atomix.gcroot(ref)
    GC.@preserve root begin
        UnsafeAtomics.store!(ptr, v, order)
    end
end

@inline function Atomix.replace!(ref, expected, desired, success_ordering, failure_ordering)
    expected = Atomix.asstorable(ref, expected)
    desired = Atomix.asstorable(ref, desired)
    ptr = Atomix.pointer(ref)
    root = Atomix.gcroot(ref)
    GC.@preserve root begin
        UnsafeAtomics.cas!(ptr, expected, desired, success_ordering, failure_ordering)
    end
end

@inline function Atomix.modify!(ref, op::OP, x, ord) where {OP}
    x = Atomix.asstorable(ref, x)
    ptr = Atomix.pointer(ref)
    root = Atomix.gcroot(ref)
    GC.@preserve root begin
        UnsafeAtomics.modify!(ptr, op, x, ord)
    end
end

Atomix.asstorable(ref, v) = convert(eltype(ref), v)

# TODO: respect ordering
module AtomixMetalExt

using Atomix: Atomix, IndexableRef
using Metal: Metal, MtlDeviceArray

const MtlIndexableRef{Indexable<:MtlDeviceArray} = IndexableRef{Indexable}

function Atomix.get(ref::MtlIndexableRef, order)
    error("not implemented")
end

function Atomix.set!(ref::MtlIndexableRef, v, order)
    error("not implemented")
end

@inline function Atomix.replace!(
    ref::MtlIndexableRef,
    expected,
    desired,
    success_ordering,
    failure_ordering,
)
    ptr = Atomix.pointer(ref)
    expected = convert(eltype(ref), expected)
    desired = convert(eltype(ref), desired)
    begin
        old = Metal.atomic_compare_exchange_weak_explicit(ptr, expected, desired)
    end
    return (; old = old, success = old === expected)
end


# CAS is needed for FP ops on ThreadGroup memory
@inline function Atomix.modify!(ref::IndexableRef{<:MtlDeviceArray{<:AbstractFloat, <:Any, Metal.AS.ThreadGroup}} , op::OP, x, order) where {OP}
    x = convert(eltype(ref), x)
    ptr = Atomix.pointer(ref)
    old = Metal.atomic_fetch_op_explicit(ptr, op, x)
    return old => op(old, x)
end

@inline function Atomix.modify!(ref::MtlIndexableRef, op::OP, x, order) where {OP}
    x = convert(eltype(ref), x)
    ptr = Atomix.pointer(ref)
    begin
        old = if op === (+)
            Metal.atomic_fetch_add_explicit(ptr, x)
        elseif op === (-)
            Metal.atomic_fetch_sub_explicit(ptr, x)
        elseif op === (&)
            Metal.atomic_fetch_and_explicit(ptr, x)
        elseif op === (|)
            Metal.atomic_fetch_or_explicit(ptr, x)
        elseif op === xor
            Metal.atomic_fetch_xor_explicit(ptr, x)
        elseif op === min
            Metal.atomic_fetch_min_explicit(ptr, x)
        elseif op === max
            Metal.atomic_fetch_max_explicit(ptr, x)
        else
            error("not implemented")
        end
    end
    return old => op(old, x)
end

end  # module AtomixMetalExt
